import { AliasNode } from '../operation-node/alias-node.js';
import { RawNode } from '../operation-node/raw-node.js';
import { SelectQueryNode } from '../operation-node/select-query-node.js';
import { RawBuilder } from '../raw-builder/raw-builder.js';
import { AliasedQueryBuilderFactory, AliasedRawBuilderFactory, AnyAliasedQueryBuilder, AnyAliasedRawBuilder, AnySelectQueryBuilder, SelectQueryBuilderFactory, RawBuilderFactory } from '../util/type-utils.js';
export declare type ComplexExpression<DB, TB extends keyof DB, V = any> = AnySelectQueryBuilder | SelectQueryBuilderFactory<DB, TB> | RawBuilder<V> | RawBuilderFactory<DB, TB, V>;
export declare type AliasedComplexExpression<DB, TB extends keyof DB> = AnyAliasedQueryBuilder | AliasedQueryBuilderFactory<DB, TB> | AnyAliasedRawBuilder | AliasedRawBuilderFactory<DB, TB>;
export declare function parseComplexExpression(exp: ComplexExpression<any, any>): SelectQueryNode | RawNode;
export declare function parseAliasedComplexExpression(exp: AliasedComplexExpression<any, any>): AliasNode;
export declare function isComplexExpression(obj: unknown): obj is ComplexExpression<any, any>;
