/// <reference types="./value-parser.d.ts" />
import { PrimitiveValueListNode } from '../operation-node/primitive-value-list-node.js';
import { ValueListNode } from '../operation-node/value-list-node.js';
import { ValueNode } from '../operation-node/value-node.js';
import { isReadonlyArray } from '../util/object-utils.js';
import { parseComplexExpression, isComplexExpression, } from './complex-expression-parser.js';
export function parseValueExpressionOrList(arg) {
    if (isReadonlyArray(arg)) {
        return parseValueExpressionList(arg);
    }
    else {
        return parseValueExpression(arg);
    }
}
export function parseValueExpression(exp) {
    if (isComplexExpression(exp)) {
        return parseComplexExpression(exp);
    }
    return ValueNode.create(exp);
}
function parseValueExpressionList(arg) {
    if (arg.some(isComplexExpression)) {
        return ValueListNode.create(arg.map((it) => parseValueExpression(it)));
    }
    return PrimitiveValueListNode.create(arg);
}
